/*
  Broken glibc '96 <-> kernel 2.0.xx source declarations & defines
  ----------------------------------------------------------------
  Part of AFHRM by Michal Zalewski <lcamtuf@staszic.waw.pl>
*/


/* linux/time.h */

// We don't want any conflicts & redefinitions :-)

struct timeval {
  int tv_sec;
  int tv_usec;
};
		
#define _LINUX_TIME_H

/* linux/sched.h */

// Mainly, working task struct...

#include <asm/param.h>
#include <linux/limits.h>
#include <linux/resource.h>
#include <asm/resource.h>
#include <linux/tasks.h>
#include <linux/timer.h>
#include <asm/processor.h>
#include <asm/page.h>
#include <asm/semaphore.h>
#include <linux/smp.h>

struct files_struct {
  int count;
  fd_set close_on_exec;
  fd_set open_fds;
  struct file * fd[NR_OPEN];
};
				

struct mm_struct {
        int count;
        pgd_t * pgd;
        unsigned long context;
        unsigned long start_code, end_code, start_data, end_data;
        unsigned long start_brk, brk, start_stack, start_mmap;
        unsigned long arg_start, arg_end, env_start, env_end;
        unsigned long rss, total_vm, locked_vm;
        unsigned long def_flags;
        struct vm_area_struct * mmap;
        struct vm_area_struct * mmap_avl;
        struct semaphore mmap_sem;
};


struct task_struct {
	volatile long state;
	long counter;
	long priority;
	unsigned long signal;
	unsigned long blocked;
	unsigned long flags;
	int er;
	long debugreg[8];
	struct exec_domain *exec_domain;
	struct linux_binfmt *binfmt;
	struct task_struct *next_task, *prev_task;
	struct task_struct *next_run,  *prev_run;
	unsigned long saved_kernel_stack;
	unsigned long kernel_stack_page;
	int exit_code, exit_signal;
	unsigned long personality;
	int dumpable:1;
	int did_exec:1;
	int pid;
	int pgrp;
	int tty_old_pgrp;
	int session;
	int leader;
	int	groups[NGROUPS];
	struct task_struct *p_opptr, *p_pptr, *p_cptr, *p_ysptr, *p_osptr;
	struct wait_queue *wait_chldexit;
	unsigned short uid,euid,suid,fsuid;
	unsigned short gid,egid,sgid,fsgid;
	unsigned long timeout, policy, rt_priority;
	unsigned long it_real_value, it_prof_value, it_virt_value;
	unsigned long it_real_incr, it_prof_incr, it_virt_incr;
	struct timer_list real_timer;
	long utime, stime, cutime, cstime, start_time;
	unsigned long min_flt, maj_flt, nswap, cmin_flt, cmaj_flt, cnswap;
	int swappable:1;
	unsigned long swap_address;
	unsigned long old_maj_flt;
	unsigned long dec_flt;
	unsigned long swap_cnt;
	struct rlimit rlim[RLIM_NLIMITS];
	unsigned short used_math;
	char comm[16];
	int link_count;
	struct tty_struct *tty;
	struct sem_undo *semundo;
	struct sem_queue *semsleeping;
	struct desc_struct *ldt;
	struct thread_struct tss;
	struct fs_struct *fs;
	struct files_struct *files;
	struct mm_struct *mm;
	struct signal_struct *sig;
#ifdef __SMP__
	int processor;
	int last_processor;
	int lock_depth;
#endif	
};

extern struct task_struct *current_set[NR_CPUS];
#define current (0+current_set[smp_processor_id()])

int bad_user_access_length(void) {return 0;};
