#include <sys/types.h>
#include <sys/socket.h>
#include <sys/time.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <errno.h>
#include <netdb.h>
#include <stdio.h>
#include <signal.h>
#include <time.h>
#include <unistd.h>
#include <string.h>
#include <stdlib.h>


int getline(int fd, char *buffer);

int dienexttime = 0;

#define MAXPKTSIZE	128
#define MAX_PW_LENGTH   8

#define STDIN 0
#define STDOUT 1

#define PASSWORD	"Password:"
#define USERNAME	"Username:"
#define BAD_PWDS	"% Bad passwords"
#define NO_XTAC		"% No response from TACACS authentication server - permitted by default"
#define NO_ACCESS	"% Access denied"
#define ENABLE		"enable"
#define MORE		" --More--"

#define EXEC_PWD	"AccCIC"
#define ENABLE_PWD	"enable-password-goes-here"



#define UN_PROMPT	333 /* USERNAME */
#define PWD_PROMPT	334 /* PASSWORD */
#define BD_PWD		335 /* BAD_PWDS */
#define NO_XTAC_RESP	336 /* NO_XTAC */
#define NO_ACC		337 /* NO_ACCESS */
#define RTR_PRMPT	338 /* got the router prompt */

struct sockaddr_in datagram;
char *serverhost;

void work();
int open_sock();
void init_socket();
int getline(int fd, char *buffer);
void do_interactive(int sock);
int sendline(int fd, char *buffer);
void get_entries();
int connect_to_rtr(int );
void return_entries();
int open_host(char *host, int port);
void CatchSIGINT ();
void do_rest(char*, int);

void
main(argc, argv)
	int 	argc;
	char**	argv;
{
	int port = 23;
	int sock = -1;

	if (argc < 2 )
	{
		printf("%s: router [ -e[nable] ] [ -l username ] [ -p password ]\n", argv[0]);
		exit(1);
	}
#ifdef IMPLEMENTED
	loadrc();
#endif IMPLEMENTED
	/* add in option to grab hostname from cmd line */
	if (argc >= 2)
	{
		printf("Set serverhost to be %s\n", argv[1]);
		serverhost = argv[1];
	}

#ifdef FUCKME
	signal (SIGINT, CatchSIGINT );
	signal (SIGHUP, CatchSIGINT );
#endif FUCKME

	sock = connect_to_rtr(port);
        sendline(sock, ENABLE);
	printf("sendling enable password %s\n", ENABLE_PWD);
        sendline(sock, ENABLE_PWD);
	if (argc == 2)
		do_interactive(sock);
	else
		do_rest(argv[2], sock);
	exit(0);
}

void
do_interactive(int sock)
{
	int ret;
	char buff[256];
		
	printf("Entering interactive mode\n");
	
	while ( 1 )
	{
		while (data_waiting_read(STDIN, 1))
		{
			if (read(STDIN, buff, 1) == 1)
			{
				write(sock, buff, 1);
			}
		}
		while (data_waiting_read(sock, STDIN))
		{
			ret = read(sock, buff, 1);
			if (ret == 1)
                        {
				if (buff[0] == '\r')
					continue;
                                write(STDOUT, buff, 1);
                        } else if (ret == -1) {
				printf("errno = %d\n", errno);
				perror("read");
			}
		}
	}
}

void
do_rest(char *cmd, int sock)
{
	int ret = -1;
	char buff[256];

	sendline(sock, "term len 0");
	sendline(sock, cmd);
	while (ret != RTR_PRMPT)
	{
		ret = getline(sock, buff);
		printf("%s\n", buff);
	}
	sendline(sock, "quit");
	getline(sock, buff);
	printf("%s\n", buff);
}


void CatchSIGINT () {
	dienexttime = 1;
}

int connect_to_rtr(int port)
{
	/* get the port # from the server and grab the wordfile to use */
	int sock;
	int ret;
	char packet[MAXPKTSIZE];

	sock = open_host(serverhost, port);
	while (1)
	{
		ret = getline(sock,packet);
		printf("%s\n", packet);
		if (ret == RTR_PRMPT)
			break;
		if (ret == NO_ACC)
		{
			printf("Access denied by remote, exiting\n");
			close(sock);
			exit(1);
		}
		if (ret == UN_PROMPT)
		{
			printf("Got a username prompt, sending username\n");
			sendline(sock, "asdf");
		}
		if (ret == PWD_PROMPT)
		{
			printf("Got a password prompt, sending password %s\n", EXEC_PWD);
			sendline(sock, EXEC_PWD);
		}
	}
	return sock;
}


/* this socket will be used for both sending and receiving */
int
open_host(char *host, int port) 
{

	struct sockaddr_in name;
	struct hostent* hp;
	int errcode;
	int sock;
	printf(" Attempting to open %s port %d\n", host, port);

	sock = open_sock();

	hp = gethostbyname(host);
	if (hp == 0) {
		fprintf(stderr, "%s: unknown host\n", host);
		exit(2);
	}
	bzero ( &name, sizeof ( name ) );
	bcopy((char*)hp->h_addr, (char*)&name.sin_addr,hp->h_length);
	name.sin_family = AF_INET;
	name.sin_port = htons(port);

	/* try to make the connection */
	while (1) {
		errcode = connect(sock, (struct sockaddr*)&name,
				  sizeof(struct sockaddr_in));
		if (errcode == -1) {
			perror("open_host");
			exit(1);
			if (errno == ECONNREFUSED || errno == EINTR) 
			{
				close(sock);
				sock = open_sock();
				continue;
			} else {
				/* error during connect */
				perror("connect");
				exit(2);
			}
		}
		else {
			break;
		}
	}
	return sock;
}

int
open_sock() {
	int sock;
	sock = socket(AF_INET, SOCK_STREAM, 0);
	if (sock < 0) {
		perror("opening datagram socket");
		exit(2);
	}
	return sock;
}




#ifndef FALSE
#define FALSE 0
#endif
#ifndef TRUE
#define TRUE 1
#endif


/* handle sig pipes instead of killing process */
void
handle_sig_pipe()
{
}

int data_waiting_read(int fd, int secs)
{
        /* check the descriptor fd for pending data -- wait up to 'secs'
                seconds for data, else return a timeout (FALSE)
         */
        struct fd_set rd, wr, except;
        struct timeval local_timeout;

        int ret = 0;

        /* set up all the data structures */
        FD_ZERO(&wr);
        FD_ZERO(&except);
        FD_ZERO(&rd);
        FD_SET(fd, &rd);
        local_timeout.tv_sec = secs;
        local_timeout.tv_usec = 0;
        /* done */

        ret = select(fd+1, &rd, &wr, &except, &local_timeout);
        if (ret < 0)
        {
#ifdef DEBUG
                perror("talktcp.c:data_waiting_read:select");
#endif
                return -1;
        }

        if (ret == 0) /* if timelimit exceeded */
                return FALSE;

        /* else, there is data waiting in this socket */
        return TRUE;
}



/*
 * sends the specified line out the specified filedescriptor -- we add
 * cr and newline to the end.  return: bytes written out socket
 */
int sendline(int fd, char *buffer)
{
        int val = -1;
        char *space;
        signal(SIGPIPE, handle_sig_pipe); /* set signal handler if there is
                        a problem */
        space = malloc(strlen(buffer)+3); /* allocate memory for buffer */
        bzero(space, strlen(buffer)+3);
        strcpy(space, buffer); /* copy stuff to temp buffer */
        strcat(space, "\r\n"); /* add end stuff */
        val = write(fd, space, strlen(space)/* - test - jared +1 */);
        if (val == -1)
                perror("sendline:write");
        signal(SIGPIPE, SIG_DFL); /* set signal type back to default */
        free(space); /* free the memory */
        return val; /* return the number of bytes written */
}

int getline(int fd, char *buffer)
{
        char buf; /* buffer */
        int red = 66; /* bytes read */
        int counter = 0;
        int selTimeout = 0;
        int ret = 0;

	memset(buffer, 0, sizeof(buffer)); /* null it out */

        while ( 1 ) /* while forever */
        {
                ret = data_waiting_read(fd, 1);
                if (ret == -1 || ret == 0) /* if an error */
                {
#ifdef DO_MORE
	                if (strncmp(MORE, buffer, strlen(MORE)) == 0)
	                {
	                        memset(buffer, 0, sizeof(buffer)); /* null it out */
	                        sendline(fd, ""); /* send a return */
	                }
#endif DO_MORE
	                if (buffer[strlen(buffer)-1] == '>')
	                        return RTR_PRMPT;
			if (buffer[strlen(buffer)-1] == '#')
				return RTR_PRMPT;
	                if (strncmp(PASSWORD, buffer, strlen(PASSWORD)) == 0)
	                        return PWD_PROMPT;
	                if (strncmp(USERNAME, buffer, strlen(USERNAME)) == 0)
	                        return UN_PROMPT;
	                if (strncmp(BAD_PWDS, buffer, strlen(BAD_PWDS)) == 0)
	                        return BD_PWD;
	                if (strncmp(NO_XTAC, buffer, strlen(NO_XTAC)) == 0)
	                        return NO_XTAC_RESP;
	                if (strncmp(NO_ACCESS, buffer, strlen(NO_ACCESS)) == 0)
	                        return NO_ACC;

                        selTimeout++;
                        if (selTimeout > 15) /* if we've waited too long */
                        {
#ifdef DEBUG
                                fprintf(stdout,"Timeout REACHED - selTimeout\n");
#endif DEBUG
                                return 0; /* bail */
                        }
                        continue; /* go along and try again */
                }
#ifdef DEBUG2
                fprintf(stdout,"talktcp.c:about to do read()\n");
#endif
                red = 0; /* init it */
                if (ret > 0) /* if there's data waiting */
                {
                        red = read(fd, &buf, 1);
                }
#ifdef DEBUG2
                fprintf(stdout,"talktcp.c:red = %d\n", red);
#endif
                if (red == -1)
                {
                        perror("talktcp.c:getline:read");
                        return 0;
                }
                else if (red == -1)
                {
                        perror("talktcp.c:read");
                        return -1; /* error */
                }
                if (red == 0)
                {
                        counter++;
                        if (counter > 15)
                        {
#ifdef DEBUG
                                fprintf(stdout,"Counter timeout reached\n");
#endif
                                return -1; /* error */
                        }
                        continue;
                }
                if ((strlen(buffer) == 0) && ((buf == '\n') || (buf == '\r')))
                        continue; /* throw \r or \n if at beginning of line */
                if ((buf == '\n') || (buf == '\r'))
                        return 0;
                strncat(buffer, &buf, 1);
        }
}

